=== debian/changelog ===
dssp (4.5.5-1) unstable; urgency=medium

  * New upstream version 4.5.5
  * temporary fix for building in Debian
  * Closes: #1106880

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sun, 31 Aug 2025 13:19:12 +0200
