=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/dssp-$1\.tar\.gz/ \
  https://github.com/PDB-REDO/dssp/tags .*/v?(\d\S+)\.tar\.gz
