## dssp 4.5.6

=== debian/changelog ===
dssp (4.5.6-1) unstable; urgency=medium

  * Update debian/salsa-ci.yml file
  * New upstream version 4.5.6

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 20 Nov 2025 09:09:03 +0100
