## dssp 4.5.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,8 +24,10 @@
 
 cmake_minimum_required(VERSION 3.23)
 
-# set the project name
-project(mkdssp VERSION 4.5.5 LANGUAGES CXX)
+file(READ libdssp/VERSION VER_FILE_CONTENT)
+string(STRIP ${VER_FILE_CONTENT} VER_FILE_CONTENT)
+
+project(mkdssp VERSION ${VER_FILE_CONTENT} LANGUAGES CXX)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
@@ -124,13 +126,13 @@
 
 # CPMFindPackage does not pass on variables set with set_and_check
 # Working around this here
-find_package(cifpp 8.0.1 QUIET)
+find_package(cifpp 9 QUIET)
 
 if(NOT cifpp_FOUND)
 	CPMAddPackage(
 		NAME cifpp
 		GIT_REPOSITORY https://github.com/pdb-redo/libcifpp.git
-		GIT_TAG v8.0.1
+		GIT_TAG v9.0.0
 		EXCLUDE_FROM_ALL YES)
 endif()
