=== debian/changelog ===
dssp (4.5.7-1) unstable; urgency=medium

  * New upstream version 4.5.7
  * Closes: #1121383

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 26 Nov 2025 10:56:41 +0100
