=== debian/control ===
--- 
+++ 
@@ -6,13 +6,10 @@
 Build-Depends: debhelper-compat (= 13),
  cmake,
  mrc,
- libcifpp-dev (>= 5.0.7.1-1~),
- libboost-dev,
- libboost-regex-dev,
- zlib1g-dev,
+ libcifpp-dev (>= 9),
  catch2,
  libmcfp-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/med-team/dssp
 Vcs-Git: https://salsa.debian.org/med-team/dssp.git
